#include <iostream>
#include <vector>
#include <string>

using namespace std;

//suffle

int main()
{
    string s;
    cin >> s;
    int l=s.length(),l1,l2;
    string s1="",s2;
    bool isti=true;
    int brojac=0;
    for(int i=0;i<l/2;i++)
    {
        if(isti)
        {
            if (s[i]!=s[l-1-i])
            {
                brojac=i;
                isti = false;
            }
        }
    }
    for(int i=brojac;i<l-brojac;i++) s1+=s[i];
    l1=s1.length();
    //cout << s1;
    int pojavljivanje[30];
    for(int i=0;i<26;i++) pojavljivanje[i]=0;
    for(int i=0;i<l1;i++) pojavljivanje[s1[i]-97]++;
    
    int pojavljivanje2[30];
    for(int i=0;i<26;i++) pojavljivanje2[i]=0;
    for(int i=0;i<l1/2;i++) pojavljivanje2[s1[i]-97]++;
    
    int pojavljivanje3[30];
    for(int i=0;i<26;i++) pojavljivanje3[i]=0;
    for(int i=l1-(l1/2);i<l1;i++) pojavljivanje3[s1[i]-97]++;
    bool jednako2=true,jednako3=true;
    
    for(int i=0;i<26;i++)
    {
        if(pojavljivanje2[i]!=pojavljivanje[i]/2)
        {
            jednako2 = false;
            break;
        }
    }
    for(int i=0;i<26;i++)
    {
        if(pojavljivanje3[i]!=pojavljivanje[i]/2)
        {
            jednako3 = false;
            break;
        }
    }
    if(jednako2+jednako3==2)
    {
        for(int i=l1/2-1;i>=0;i--)
        {
            if(s1[i]!=s1[l1-1-i])
            {
                cout << i+1;
                return 0;
            }
        }
        cout << 1;
        return 0;
    }
    int k1=0,k2=0;
    for(int i=l1/2;i<l1;i++)
    {
        pojavljivanje2[s1[i]-97]++;
        for(int j=0;j<26;j++) 
        {
            if(pojavljivanje2[j]<(pojavljivanje[j]+1)/2) break;
            if(j==25) k1=i+1;
        }
        if(k1>0) break;
    }
    for(int i=(l1-1)/2;i>=0;i--)
    {
        pojavljivanje3[s1[i]-97]++;
        for(int j=0;j<26;j++) 
        {
            if(pojavljivanje3[j]<(pojavljivanje[j]+1)/2) break;
            if(j==25)
            {
                k2=l1-i;
                //cout << i << ";)\n";
            }
        }
        if(k2>0) break;
    }
    if(k1<k2) cout << k1;
    else cout << k2;
    return 0;
}